XMKDIR_ROUTINE
.(
  ; [IN] AX contains the pointer of the path
  ; FIXME
  
    sta     RES
    stx     RES+1

    jsr     _ch376_verify_SetUsbPort_Mount
    cmp     #$01
    bne     next  
    lda     #ENODEV 
    rts
next  
    ; is it an absolute path ?
    ldy     #$00
    lda     (RES),y
    cmp     #"/"
    beq     isabsolute
    ldx     #$00
loop  
    lda     ORIX_PATH_CURRENT,x
    beq     end_of_pwd_copy
    sta     volatile_str,x
    inx
    bne      loop
end_of_pwd_copy  
    lda     (RES),y
    beq     end_of_path_copy
    sta     volatile_str,x
    iny
    inx
    bne     end_of_pwd_copy  
end_of_path_copy  
    ; At this step A contains A
    sta     volatile_str,x
    lda     #<volatile_str
    sta     RES
    lda     #>volatile_str
    sta     RES+1
 
isabsolute  
    jsr     _open_root_and_enter
    ldy     #$00                   ; skip /
next_folder
    ldx     #$00
next_char  
    iny
    lda     (RES),y
    beq     end
    cmp     #"/"
    beq     create_dir
    sta     BUFNOM,x

    inx
    bne     next_char
end
    ; Create last folder
    ; Store 0

    sta     BUFNOM,x
    jsr     _ch376_set_file_name
    jsr     _ch376_dir_create
    lda     #$00
    rts
  
create_dir
    lda     #$00
    sta     BUFNOM,x
    sty     TR7   ; save Y
    jsr     _ch376_set_file_name
    sta     ERRNO
    jsr     _ch376_dir_create
    ldy     TR7
    jmp     next_folder
.)
